package org.apache.bcel.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.Hashtable;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Utility;

@Deprecated
/* loaded from: org_apache_bcel_util.jar:org/apache/bcel/util/ClassLoader.class */
public class ClassLoader extends java.lang.ClassLoader {
    private static final String BCEL_TOKEN = "$$BCEL$$";
    public static final String[] DEFAULT_IGNORED_PACKAGES = {"java.", "javax.", "sun."};
    private final Hashtable<String, Class<?>> classes;
    private final String[] ignoredPackages;
    private Repository repository;

    public ClassLoader() {
        this(DEFAULT_IGNORED_PACKAGES);
    }

    public ClassLoader(java.lang.ClassLoader deferTo) {
        super(deferTo);
        this.classes = new Hashtable<>();
        this.repository = SyntheticRepository.getInstance();
        this.ignoredPackages = DEFAULT_IGNORED_PACKAGES;
        this.repository = new ClassLoaderRepository(deferTo);
    }

    public ClassLoader(java.lang.ClassLoader deferTo, String[] ignoredPackages) {
        this(ignoredPackages);
        this.repository = new ClassLoaderRepository(deferTo);
    }

    public ClassLoader(String[] ignoredPackages) {
        this.classes = new Hashtable<>();
        this.repository = SyntheticRepository.getInstance();
        this.ignoredPackages = ignoredPackages;
    }

    protected JavaClass createClass(String className) {
        int index = className.indexOf(BCEL_TOKEN);
        String realName = className.substring(index + BCEL_TOKEN.length());
        try {
            byte[] bytes = Utility.decode(realName, true);
            ClassParser parser = new ClassParser(new ByteArrayInputStream(bytes), "foo");
            JavaClass clazz = parser.parse();
            ConstantPool cp = clazz.getConstantPool();
            ConstantClass cl = cp.getConstant(clazz.getClassNameIndex(), (byte) 7, ConstantClass.class);
            ConstantUtf8 name = cp.getConstantUtf8(cl.getNameIndex());
            name.setBytes(className.replace('.', '/'));
            return clazz;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override // java.lang.ClassLoader
    protected Class<?> loadClass(String className, boolean resolve) throws ClassNotFoundException {
        JavaClass clazz;
        Class<?> cls = this.classes.get(className);
        Class<?> cl = cls;
        if (cls == null) {
            String[] strArr = this.ignoredPackages;
            int length = strArr.length;
            int i = 0;
            while (true) {
                if (i >= length) {
                    break;
                }
                String ignoredPackage = strArr[i];
                if (!className.startsWith(ignoredPackage)) {
                    i++;
                } else {
                    cl = getParent().loadClass(className);
                    break;
                }
            }
            if (cl == null) {
                if (className.contains(BCEL_TOKEN)) {
                    clazz = createClass(className);
                } else {
                    JavaClass clazz2 = this.repository.loadClass(className);
                    if (clazz2 == null) {
                        throw new ClassNotFoundException(className);
                    }
                    clazz = modifyClass(clazz2);
                }
                if (clazz != null) {
                    byte[] bytes = clazz.getBytes();
                    cl = defineClass(className, bytes, 0, bytes.length);
                } else {
                    cl = Class.forName(className);
                }
            }
            if (resolve) {
                resolveClass(cl);
            }
        }
        this.classes.put(className, cl);
        return cl;
    }

    protected JavaClass modifyClass(JavaClass clazz) {
        return clazz;
    }
}
